
//+------------------------------------------------------------------+ 
//| Support and Resistance | 
//| Copyright ? 2004 Barry Stander | 
//| http://myweb.absa.co.za/stander/4meta/ | 
//+------------------------------------------------------------------+ 
#property copyright "Click here: Barry Stander" 
#property link "http://myweb.absa.co.za/stander/4meta/" 

#property indicator_chart_window 
#property indicator_buffers 2 
#property indicator_color1 Red 
#property indicator_color2 Blue 


extern int myWingDing  = 119 ;
extern bool Horizontal = true ;
extern int myChartY = 50 ;


//---- buffers 
double v1[]; 
double v2[]; 

double val1; 
double val2; 

double xPos[]; 

int i; 
//+------------------------------------------------------------------+ 
//| | 
//+------------------------------------------------------------------+ 
int init() 
{ 
//---- drawing settings 
SetIndexArrow(0, myWingDing); 
SetIndexArrow(1, myWingDing); 
//---- 
SetIndexStyle(0, DRAW_ARROW, STYLE_DOT ,  1); 
SetIndexDrawBegin(0, i-1); 
SetIndexBuffer(0, v1); 
SetIndexLabel(0,"Resistance"); 
//---- 
SetIndexStyle(1, DRAW_ARROW, STYLE_DOT , 1); 
SetIndexDrawBegin(1,i-1); 
SetIndexBuffer(1, v2); 
SetIndexLabel(1,"Support"); 
//---- 
return(0); 
} 

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   
   ObjectDelete("SupRes");
   ObjectDelete("line5SupRes");
   ObjectDelete("R3_LabelOHLMC");
   ObjectDelete("R3_ValueOHLMC");
   ObjectDelete("R2_LabelOHLMC");
   ObjectDelete("R2_ValueOHLMC");
   
   return(0);
  }

//+------------------------------------------------------------------+ 
//| | 
//+------------------------------------------------------------------+ 
int start() 
{ 
i = Bars; 
while(i >= 0) 
{ 

val1 = iFractals(NULL, 0, MODE_UPPER, i); 
//---- 
if(val1 > 0) {
v1[i] = High[i]; 
double R3 = v1[i] ; }
else 
if (Horizontal) {v1[i] = v1[i+1]; }

 

val2 = iFractals(NULL, 0, MODE_LOWER, i); 
//---- 
if(val2 > 0) {
v2[i] = Low[i]; 
double R2 = v2[i] ; }
else 
if (Horizontal) {v2[i] = v2[i+1]; }

i--; 
} 

double xRet = Close[0] - R2 ;

double xRetPct =  ( 100 * xRet ) / ( R3 - R2 );

//+------------------------------------------------------------------+ 
   color color_pivots_1=White;
   color color_res     =Red;  
   color color_sup     =Blue;   
   color color_ret     =White; 
   color color_retpct  =White;   
    
   color color_r3=Red;
   color color_r2=Red;
   color color_r1=White;
   color color_p =White;
   
	if( Close[0] < R3) { color_r3=Lime; } 
	if( Close[0] < R2) { color_r2=Lime; } 
	
	int Precision, dig;	

   if( StringFind( Symbol(), "JPY", 0) != -1 ) { Precision = 100; dig = 2;}
   else                                        { Precision = 10000; dig = 4; }

 
 
int sPeriod= Period();
  
     	
//---- Set Pivots labels

   int WindowToUse;
   int Corner_line, Xdist_line;
   int Corner_text, Corner_value, Xdist_text, Xdist_value;
   int Ydist_line5;
   int Corner_pivots, Xdist_pivots, Ydist_pivots;
   int Ydist_R3, Ydist_R2, Ydist_R1, Ydist_PV, Ydist_S1, Ydist_S2, Ydist_S3;
  
   int YdistInc ;
    WindowToUse =  0;
    Corner_line = 1;
    Corner_text = 1; Corner_value = 1;
    Xdist_line = 21; Xdist_text = 93; Xdist_value = 23;
    Corner_pivots = 1; Xdist_pivots = 21; 
    Ydist_pivots = myChartY;  
    Ydist_line5 = Ydist_pivots + 11; YdistInc = 15 ;
    Ydist_R3 = Ydist_pivots + 25; 
    Ydist_R2 = Ydist_R3 + YdistInc; 
    Ydist_R1 = Ydist_R3 + YdistInc*2; 
    Ydist_PV = Ydist_R3 + YdistInc*3; 
    Ydist_S1 = Ydist_R3 + YdistInc*4; 
    Ydist_S2 = Ydist_R3 + YdistInc*5; 
    Ydist_S3 = Ydist_R3 + YdistInc*6;

   ObjectCreate("SupRes", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("SupRes",sPeriod + " SupRes ",9, "Verdana", color_pivots_1);
   ObjectSet("SupRes", OBJPROP_CORNER, Corner_pivots);
   ObjectSet("SupRes", OBJPROP_XDISTANCE, Xdist_pivots);
   ObjectSet("SupRes", OBJPROP_YDISTANCE, Ydist_pivots);
   
   ObjectCreate("line5SupRes", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("line5SupRes","---------------------",7, "Verdana", color_pivots_1);
   ObjectSet("line5SupRes", OBJPROP_CORNER, Corner_line);
   ObjectSet("line5SupRes", OBJPROP_XDISTANCE, Xdist_line);
   ObjectSet("line5SupRes", OBJPROP_YDISTANCE, Ydist_line5);
   
   ObjectCreate("R3_Label", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("R3_Label","Res  ",9, "Verdana", color_res);
   ObjectSet("R3_Label", OBJPROP_CORNER, Corner_text);
   ObjectSet("R3_Label", OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet("R3_Label", OBJPROP_YDISTANCE, Ydist_R3);
   
   ObjectCreate("R3_Value", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("R3_Value"," "+DoubleToStr(R3,dig),9, "Verdana", color_r3);
   ObjectSet("R3_Value", OBJPROP_CORNER, Corner_value);
   ObjectSet("R3_Value", OBJPROP_XDISTANCE, Xdist_value);
   ObjectSet("R3_Value", OBJPROP_YDISTANCE, Ydist_R3);
   
   ObjectCreate("R2_Label", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("R2_Label","Sup  ",9, "Verdana", color_sup);
   ObjectSet("R2_Label", OBJPROP_CORNER, Corner_text);
   ObjectSet("R2_Label", OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet("R2_Label", OBJPROP_YDISTANCE, Ydist_R2);
   
   ObjectCreate("R2_Value", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("R2_Value"," "+DoubleToStr(R2,dig),9, "Verdana", color_r2);
   ObjectSet("R2_Value", OBJPROP_CORNER, Corner_value);
   ObjectSet("R2_Value", OBJPROP_XDISTANCE, Xdist_value);
   ObjectSet("R2_Value", OBJPROP_YDISTANCE, Ydist_R2);
   
   ObjectCreate("R1_Label", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("R1_Label","Ret  ",9, "Verdana", color_r1 );
   ObjectSet("R1_Label", OBJPROP_CORNER, Corner_text);
   ObjectSet("R1_Label", OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet("R1_Label", OBJPROP_YDISTANCE, Ydist_R1);
   
   ObjectCreate("R1_Value", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("R1_Value"," "+DoubleToStr(xRet,dig),9, "Verdana", color_r1);
   ObjectSet("R1_Value", OBJPROP_CORNER, Corner_value);
   ObjectSet("R1_Value", OBJPROP_XDISTANCE, Xdist_value);
   ObjectSet("R1_Value", OBJPROP_YDISTANCE, Ydist_R1);
   
   ObjectCreate("Pivot_Label", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("Pivot_Label","Ret%",9, "Verdana", White);
   ObjectSet("Pivot_Label", OBJPROP_CORNER, Corner_text);
   ObjectSet("Pivot_Label", OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet("Pivot_Label", OBJPROP_YDISTANCE, Ydist_PV);
   
   ObjectCreate("Pivot_Value", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("Pivot_Value"," "+DoubleToStr(xRetPct,dig),9, "Verdana", color_p);
   ObjectSet("Pivot_Value", OBJPROP_CORNER, Corner_value);
   ObjectSet("Pivot_Value", OBJPROP_XDISTANCE, Xdist_value);
   ObjectSet("Pivot_Value", OBJPROP_YDISTANCE, Ydist_PV);   
   
   return(0); 
} 